﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.RSSBus.QuickBooks;
using System.Data;

namespace cacheinvoicesDemo
{
  class AutoUpdate
  {

    private Timer timer1 = new Timer();
    private String[] tables;
    String connectionString;

    public void SetupTimer(String connstr, String[] TableNames, int seconds)
    {
      connectionString = connstr;
      tables = TableNames;
      timer1.Interval = seconds * 1000;
      timer1.Tick += new System.EventHandler(this.UpdateCache);
    }

    private void UpdateCache(object sender, EventArgs e)
    {
      UpdateCache();
    }

    public void UpdateCache()
    {
      for (int i = 0; i < tables.Length; i++)
      {
        UpdateTable(tables[i]);
      }
    }

    public void UpdateTable(String tablename)
    {
      DataTable table = new DataTable();

      // First, get the most recent modified time from the cache. Set Query Passthrough to true to run directly against SQLite.
      String connstr = connectionString.Replace("Offline=False", "Offline=True");
      QuickBooksDataAdapter dataAdapter = new QuickBooksDataAdapter("SELECT MAX(TimeModified) as MaxTime FROM " + tablename, connstr);
      dataAdapter.Fill(table);

      // Now set that to be our most recent date. If there are no rows, set date = 1970-01-01.
      String date;
      try
      {
        date = (String)table.Rows[0]["MaxTime"];
      }
      catch (Exception ex)
      {
          MessageBox.Show(ex.Message);
        date = "1970-01-01";
      }
      table.Rows.Clear();
      table.Columns.Clear();

      // Now search the live data source for only modified dates as new or newer than the one we found. Filling a 
      // table will cause the cache to be updated with the results when Auto Cache=True in the connection string.
      // Also, set MaxResults=0 to return all results from the live Data Source.
      connstr = connstr.Replace("Offline=True", "Offline=False");
      connstr = connstr.Replace("Query Passthrough=True", "Query Passthrough=False");
      QuickBooksConnection conn = new QuickBooksConnection(connstr);
      dataAdapter = new QuickBooksDataAdapter("SELECT * FROM " + tablename + " WHERE StartModifiedDate = '" + date + "'", conn);
      dataAdapter.Fill(table);
    }

    public void StartTimer()
    {
      timer1.Enabled = true;
    }

    public void StopTimer()
    {
      timer1.Enabled = false;
    }

    public Boolean timerIsStarted()
    {
      return timer1.Enabled;
    }
  }
}
